Find all reachable nodes from every node present in a given set - GeeksforGeeks
Given an undirected graph and a set of vertices, find all reachable nodes from every vertex present in the given set.
Consider below undirected graph with 2 disconnected components.
One straight forward solution is to do a BFS traversal for every node present in the set and then find all the reachable nodes.
Assume that we need to find reachable nodes for n nodes, the time complexity for this solution would be O(n*(V+E)) where V is number of nodes in the graph and E is number of edges in the graph. Please note that we need to call BFS as a separate call for every node without using the visited array of previous traversals because a same vertex may need to be printed multiple times. This seems to be an effective solution but consider the case when E = Θ(V2) and n = V, time complexity becomes O(V3).
Read full article from Find all reachable nodes from every node present in a given set - GeeksforGeeks
Given an undirected graph and a set of vertices, find all reachable nodes from every vertex present in the given set.
Consider below undirected graph with 2 disconnected components.
arr[] = {1 , 2 , 5} Reachable nodes from 1 are 1, 2, 3, 4 Reachable nodes from 2 are 1, 2, 3, 4 Reachable nodes from 5 are 5, 6, 7Since the given graph is undirected, all vertices that belong to same component have same set of reachable nodes. So we keep track of vertex and component mappings. Every component in the graph is assigned a number and every vertex in this component is assigned this number. We use the visit array for this purpose, the array which is used to keep track of visited vertices in BFS.
For a node u, if visit[u] is 0 then u has not been visited before else // if not zero then visit[u] represents the component number. For any two nodes u and v belonging to same component, visit[u] is equal to visit[v]
To store the reachable nodes, use a map m with key as component number and value as a vector which stores all the reachable nodes.
To find reachable nodes for a node u return m[visit[u]]
Look at the pseudo code below in order to understand how to assign component numbers.
To find reachable nodes for a node u return m[visit[u]]
Look at the pseudo code below in order to understand how to assign component numbers.
componentNum = 0 for i=1 to n If visit[i] is NOT 0 then componentNum++ // bfs() returns a list (or vector) // for given vertex 'i' list = bfs(i, componentNum) m[visit[i]]] = list
For the graph shown in the example the visit array would be.
For the nodes 1, 2, 3 and 4 the component number is 1. For nodes 5, 6 and 7 the component number is 2.
For the nodes 1, 2, 3 and 4 the component number is 1. For nodes 5, 6 and 7 the component number is 2.
Time Complexity Analysis:
n = Size of the given set
E = Number of Edges
V = Number of Nodes
O(V+E) for BFS
In worst case all the V nodes are displayed for each node present in the given, i.e only one component in the graph so it takes O(n*V) time.
n = Size of the given set
E = Number of Edges
V = Number of Nodes
O(V+E) for BFS
In worst case all the V nodes are displayed for each node present in the given, i.e only one component in the graph so it takes O(n*V) time.
Worst Case Time Complexity : O(V+E) + O(n*V)
class
Graph
{
public
:
int
V;
// No. of vertices
// Pointer to an array containing adjacency lists
list<
int
> *adj;
Graph(
int
);
// Constructor
void
addEdge(
int
,
int
);
vector<
int
> BFS(
int
,
int
,
int
[]);
};
Graph::Graph(
int
V)
{
this
->V = V;
adj =
new
list<
int
>[V+1];
}
void
Graph::addEdge(
int
u,
int
v)
{
adj[u].push_back(v);
// Add w to v’s list.
adj[v].push_back(u);
// Add v to w’s list.
}
vector<
int
> Graph::BFS(
int
componentNum,
int
src,
int
visited[])
{
// Mark all the vertices as not visited
// Create a queue for BFS
queue<
int
> queue;
queue.push(src);
// Assign Component Number
visited[src] = componentNum;
// Vector to store all the reachable nodes from 'src'
vector<
int
> reachableNodes;
while
(!queue.empty())
{
// Dequeue a vertex from queue
int
u = queue.front();
queue.pop();
reachableNodes.push_back(u);
// Get all adjacent vertices of the dequeued
// vertex u. If a adjacent has not been visited,
// then mark it visited nd enqueue it
for
(
auto
itr = adj[u].begin();
itr != adj[u].end(); itr++)
{
if
(!visited[*itr])
{
// Assign Component Number to all the
// reachable nodes
visited[*itr] = componentNum;
queue.push(*itr);
}
}
}
return
reachableNodes;
}
// Display all the Reachable Nodes from a node 'n'
void
displayReachableNodes(
int
n,
unordered_map <
int
, vector<
int
> > m)
{
vector<
int
> temp = m[n];
for
(
int
i=0; i<temp.size(); i++)
cout << temp[i] <<
" "
;
cout << endl;
}
// Find all the reachable nodes for every element
// in the arr
void
findReachableNodes(Graph g,
int
arr[],
int
n)
{
// Get the number of nodes in the graph
int
V = g.V;
// Take a integer visited array and initialize
// all the elements with 0
int
visited[V+1];
memset
(visited, 0,
sizeof
(visited));
// Map to store list of reachable Nodes for a
// given node.
unordered_map <
int
, vector<
int
> > m;
// Initialize component Number with 0
int
componentNum = 0;
// For each node in arr[] find reachable
// Nodes
for
(
int
i = 0 ; i < n ; i++)
{
int
u = arr[i];
// Visit all the nodes of the component
if
(!visited[u])
{
componentNum++;
// Store the reachable Nodes corresponding to
// the node 'i'
m[visited[u]] = g.BFS(componentNum, u, visited);
}
// At this point, we have all reachable nodes
// from u, print them by doing a look up in map m.
cout <<
"Reachable Nodes from "
<< u <<
" are\n"
;
displayReachableNodes(visited[u], m);
}
}
One straight forward solution is to do a BFS traversal for every node present in the set and then find all the reachable nodes.
Assume that we need to find reachable nodes for n nodes, the time complexity for this solution would be O(n*(V+E)) where V is number of nodes in the graph and E is number of edges in the graph. Please note that we need to call BFS as a separate call for every node without using the visited array of previous traversals because a same vertex may need to be printed multiple times. This seems to be an effective solution but consider the case when E = Θ(V2) and n = V, time complexity becomes O(V3).